# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Member Functions | Private Attributes | List of all members
dirac::EntropyCorrector Class Reference

A class used for correcting estimates of entropy. More...

`#include <common.h>`

Collaboration diagram for dirac::EntropyCorrector:
[legend]

## Public Member Functions
| EntropyCorrector (int depth)
| Constructor. More...
float | Factor (const int bandnum, const PictureParams &pp, const CompSort c) const
| Returns the correction factor. More...
void | Update (int bandnum, const PictureParams &pp, CompSort c, int est_bits, int actual_bits)
| Update the correction factors. More...

## Private Member Functions
void | Init ()
| Initialises the correction factors. More...

## Private Attributes
TwoDArray< float > | m_Yfctrs
TwoDArray< float > | m_Ufctrs
TwoDArray< float > | m_Vfctrs

## Detailed Description

A class used by the encoder for correcting estimates of entropy. Used for selecting quantisers in subband coefficient coding. Factors can be adjusted in the light of previous experience.

## Constructor & Destructor Documentation

## ◆ EntropyCorrector()

dirac::EntropyCorrector::EntropyCorrector | ( | int | depth | ) |

Constructs arrays of correction factors of size.

Parameters

  depth | the depth of the wavelet transform.

## Member Function Documentation

## ◆ Factor()

float dirac::EntropyCorrector::Factor | ( | const int | bandnum,
|  | const PictureParams & | pp,
|  | const CompSort | c
| ) |  | const

Returns the correction factor for the band given also the type of picture and component.

## ◆ Init()

void dirac::EntropyCorrector::Init | ( |  | ) |
| private

## ◆ Update()

void dirac::EntropyCorrector::Update | ( | int | bandnum,
|  | const PictureParams & | pp,
|  | CompSort | c,
|  | int | est_bits,
|  | int | actual_bits
| ) |  |

Update the factors for a given subband, component and picture type.

Parameters

  bandnum | the number of the subband to update
  pp | picture parameters
  c | component type
  est_bits | the number of bits it was estimated would be used
  actual_bits | the number of bits that actually were used

## Member Data Documentation

## ◆ m_Ufctrs

TwoDArray<float> dirac::EntropyCorrector::m_Ufctrs
| private

## ◆ m_Vfctrs

TwoDArray<float> dirac::EntropyCorrector::m_Vfctrs
| private

## ◆ m_Yfctrs

TwoDArray<float> dirac::EntropyCorrector::m_Yfctrs
| private

The documentation for this class was generated from the following file:

- common.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.